/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package statnimesic;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import javafx.application.Platform;
import javafx.concurrent.Task;

/**
 *
 * @author krajskeOndrej
 */
public class Game {

    public int doleva;
    public int doprava;
    public int nahoru;

    private final int WAIT_FOR = 90;//milis

    private final String adress;
    private DataPack dp = new DataPack();

    public Game(String adress) {
        this.adress = adress;
    }

    
    public void startGame() {
        DataPack tmp = this.innerStart();
        System.out.println("TMP:\n" + tmp);

        Thread thr = new Thread() {
            @Override
            public void run() {
                while (dp.stav == 0) {
                    try {
                        Thread.sleep(WAIT_FOR);

                        actualize(dp.ID, doleva, doprava, nahoru);
                        System.out.println("");
                    } catch (InterruptedException ex) {
                        System.err.println(ex);
                    }
                }
                String tmp = getResultFromServer();
                System.out.println(tmp);
                Platform.runLater(() -> FXMLDocumentController.lst.setoutputLabel(tmp));
            }

        };
        thr.start();
    }

    public DataPack innerStart() {
        try {
            DataPack dp = new DataPack();

            StringBuilder result = new StringBuilder();
            String urlStr = adress + "/start";
            URL url = new URL(urlStr);
            System.out.println(urlStr);

            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("GET");
            BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line;
            String[] splitLine;
            if ((line = rd.readLine()) != null) {
                dp.ID = Integer.valueOf(line);
            }
            if ((line = rd.readLine()) != null) {
                splitLine = line.split(" ");
                dp.X = Double.valueOf(splitLine[0]);
                dp.Y = Double.valueOf(splitLine[1]);
            }
            if ((line = rd.readLine()) != null) {
                splitLine = line.split(" ");
                dp.Vx = Double.valueOf(splitLine[0]);
                dp.Vy = Double.valueOf(splitLine[1]);
            }
            if ((line = rd.readLine()) != null) {
                dp.P = Double.valueOf(line);
                dp.palivoPuvodni=dp.P;
            }
            if ((line = rd.readLine()) != null) {
                splitLine = line.split(" ");
                dp.L = Double.valueOf(splitLine[0]);
                dp.R = Double.valueOf(splitLine[1]);
            }
            rd.close();
            System.out.println("GAME STARTED!");
            this.dp = dp;
            return dp;
        } catch (Exception ex) {
            System.err.println(ex);
        }
        return null;
    }

    public void actualize(long id, int doleva, int doprava, int nahoru, DataPack pack) {
        System.out.println("res: " + innerSend(id, doleva, doprava, nahoru));
        System.out.println("dp: " + dp);

        Platform.runLater(() -> FXMLDocumentController.lst.render());
    }

    public void actualize(long id, int doleva, int doprava, int nahoru) {
        actualize(id, doleva, doprava, nahoru, dp);
    }

    public String innerSend(long id, int doleva, int doprava, int nahoru) {
        try {
            StringBuilder result = new StringBuilder();
            String urlStr = adress + "/stav?id=" + id + "&doleva=" + doleva + "&doprava=" + doprava + "&nahoru=" + nahoru;
            URL url = new URL(urlStr);
            System.out.println(urlStr);

            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("GET");
            BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line;
            String[] splitLine;
            if ((line = rd.readLine()) != null) {
                dp.ID = Integer.valueOf(line);
                result.append(line);
            } else {
                dp.stav = -1;
            }
            if ((line = rd.readLine()) != null) {
                splitLine = line.split(" ");
                dp.X = Double.valueOf(splitLine[0]);
                dp.Y = Double.valueOf(splitLine[1]);
            }
            if ((line = rd.readLine()) != null) {
                splitLine = line.split(" ");
                dp.Vx = Double.valueOf(splitLine[0]);
                dp.Vy = Double.valueOf(splitLine[1]);
            }
            if ((line = rd.readLine()) != null) {
                dp.P = Double.valueOf(line);
            }
            if ((line = rd.readLine()) != null) {
                splitLine = line.split(" ");
                dp.L = Double.valueOf(splitLine[0]);
                dp.R = Double.valueOf(splitLine[1]);
            }
            rd.close();
            return result.toString();
        } catch (Exception ex) {
            System.err.println("ups");
            dp.stav = -2;
        }
        return null;
    }

    private String getResultFromServer() {
        try {
            StringBuilder result = new StringBuilder();
            String urlStr = adress +"/stav?id=" + dp.ID;
            URL url = new URL(urlStr);
            System.out.println(urlStr);

            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("GET");
            BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line;
            while ((line = rd.readLine()) != null) {
                result.append(line);
            } 
            rd.close();
            return result.toString();
        } catch (Exception ex) {
            System.err.println("");
        }
        return null;
    }

    //--------------------------------------//--------------------------------------//--------------------------------------
    //--------------------------------------//--------------------------------------//--------------------------------------
    //--------------------------------------//--------------------------------------//--------------------------------------
    //--------------------------------------//--------------------------------------//--------------------------------------
    //--------------------------------------//--------------------------------------//--------------------------------------
    //--------------------------------------//--------------------------------------//--------------------------------------
    //--------------------------------------//--------------------------------------//--------------------------------------
    //
    public DataPack getDp() {
        return dp;
    }

    public String getAdress() {
        return adress;
    }

}
